import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import descriptor.*;

public class Main {
    public static void main(String[] args){
        Main main = new Main();
        List list = main.createAttributeDescriptors();
        Iterator it = list.iterator();
        while(it.hasNext()){
            System.out.println("class name is : " + it.next().getClass().getName());
        }
    }

    public List createAttributeDescriptors(){
        List result = new ArrayList();

        result.add(forInteger("remoteId", getClass(), Integer.TYPE));
        result.add(forDate("createDate", getClass(), Date.class));
        result.add(forDate("lastChangeDate", getClass(), Date.class));
        result.add(forReference("createdBy", getClass(), User.class, RemoteUser.class));
        result.add(forReference("lastChangedBy", getClass(), User.class, RemoteUser.class));
        result.add(forInteger("optimisticLockVersion", getClass(), Integer.TYPE));

        return result;
    }
    public static DefaultDescriptor forInteger(String column, Class cls,int type){
        return new DefaultDescriptor(column,cls,type);
    }
    public static DefaultDescriptor forDate(String column, Class cls,Class type){
        return new DefaultDescriptor(column,cls,type);
    }
    public static ReferenceDescriptor forReference(String column, Class cls,Class user,Class remoteUser){

        return new ReferenceDescriptor(column, cls, user, remoteUser);
    }
 
}

class Integer {
    public static int TYPE = 0;
}

class Date {
}

class User {
}

class RemoteUser {
}

